/****************************************************************************
 * include/nuttx/wireless/generic/ioctl.h
 *
 *   Copyright (C) 2017 Sebastien Lorquet. All rights reserved.
 *   Author: Sebastien Lorquet <sebastien@lorquet.fr>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 * 3. Neither the name NuttX nor the names of its contributors may be
 *    used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 ****************************************************************************/

#ifndef __INCLUDE_NUTTX_WIRELESS_GENERIC_IOCTL_H
#define __INCLUDE_NUTTX_WIRELESS_GENERIC_IOCTL_H

/****************************************************************************
 * Included Files
 ****************************************************************************/

#include <nuttx/config.h>
#include <nuttx/fs/ioctl.h>

/****************************************************************************
 * Pre-Processor Definitions
 ****************************************************************************/

#define GRIOCSETBFREQ _GRIOC(0x0001) /* uint32_t  */
#define GRIOCGETBFREQ _GRIOC(0x0002) /* uint32_t* */
#define GRIOCSETCHSPC _GRIOC(0x0003) /* uint32_t  */
#define GRIOCGETCHSPC _GRIOC(0x0004) /* uint32_t* */
#define GRIOCSETCHAN  _GRIOC(0x0005) /* int32_t   */
#define GRIOCGETCHAN  _GRIOC(0x0006) /* int32_t*  */
#define GRIOCSETDRATE _GRIOC(0x0007) /* uint32_t  */
#define GRIOCGETDRATE _GRIOC(0x0008) /* uint32_t* */
#define GRIOCSETMOD   _GRIOC(0x0009) /* uint32_t  */
#define GRIOCGETMOD   _GRIOC(0x000A) /* uint32_t* */
#define GRIOCSETMODI  _GRIOC(0x000B) /* uint32_t  */
#define GRIOCGETMODI  _GRIOC(0x000C) /* uint32_t* */
#define GRIOCSETDEV   _GRIOC(0x000D) /* uint32_t  */
#define GRIOCGETDEV   _GRIOC(0x000E) /* uint32_t* */
#define GRIOCGETGBT   _GRIOC(0x000F) /* uint32_t* */
#define GRIOCSETGBT   _GRIOC(0x0010) /* uint32_t  */
#define GRIOCSETPLEN  _GRIOC(0x0011) /* uint32_t  */
#define GRIOCGETPLEN  _GRIOC(0x0012) /* uint32_t* */
#define GRIOCSETSYNC  _GRIOC(0x0013) /* struct genradio_synciocparam_s */
#define GRIOCGETSYNC  _GRIOC(0x0014) /* struct genradio_synciocparam_s */
#define GRIOCSETRXBW  _GRIOC(0x0015) /* uint32_t  */
#define GRIOCGETRXBW  _GRIOC(0x0016) /* uint32_t* */
#define GRIOCGETRSSI  _GRIOC(0x0017) /* int32_t*  */
#define GRIOCGETLQI   _GRIOC(0x0018) /* int32_t*  */
#define GRIOCSETTXPW  _GRIOC(0x0019) /* int32_t   */
#define GRIOCGETTXPW  _GRIOC(0x001A) /* int32_t*  */

/****************************************************************************
 * Public Types
 ****************************************************************************/

struct genradio_synciocparam_s
{
  uint8_t  *data; /* sync word bits */
  uint32_t len;   /* sync word len in bits */
};

#ifdef __cplusplus
#define EXTERN extern "C"
extern "C"
{
#else
#define EXTERN extern
#endif

/****************************************************************************
 * Public Function Prototypes
 ****************************************************************************/

#undef EXTERN
#ifdef __cplusplus
}
#endif

#endif /* __INCLUDE_NUTTX_WIRELESS_GENERIC_IOCTL_H */

